<?php
/*
Plugin Name: WooCommerce Product and Stock Manager
Plugin URI: https://essentialplugins.com/
Description: WooCommerce Product and Stocks Report WordPress Plugin
Author: Essential Plugins
Author URI: https://essentialplugins.com
Version: 1.0

*/

if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins'))))
  {
    if (!class_exists('WS_Manager'))
      {
        /**
         * Localisation
         *
         */
        load_plugin_textdomain('WS_Manager', false, dirname(plugin_basename(__FILE__)) . '/');
        class WS_Manager
          {
            public function __construct()
              {

                // called only after woocommerce has finished loading
                add_action('woocommerce_init', array(&$this,
                    'woocommerce_loaded'
                ));

                // called after all plugins have loaded
                add_action('plugins_loaded', array(&$this,
                    'plugins_loaded'
                ));

                // called just before the woocommerce template functions are included
                

                add_action('admin_menu', 'wsesp_plugin_menu');

                // indicates we are running the admin
                if (is_admin())
                  {

                    // ...
                    
                  }

                // indicates we are being served over ssl
                if (is_ssl())
                  {

                    // ...
                    
                  }

                add_action('wp_ajax_wsesp_inline_products', 'wsesp_ajax_1');
                add_action('wp_ajax_wsesp_get_variation_data', 'wsesp_ajax_2');

              

                function wsesp_ajax_1()
                  {

                    $reponse = array();

                    $column = $_POST['column'];

                    $val = $_POST['editval'];

                    $id = $_POST['id'];
                    if ($column != 'category')
                      {

                        $val = str_replace('&lt;br&gt;', '', $val);
                        $val = trim($val);

                      }

                    global $wpdb;

                    if ($column == 'stock_left')
                      {

                        $table_name = $wpdb->prefix . 'postmeta';
                        $query = " UPDATE $table_name SET meta_value = '$val' WHERE post_id = '$id' AND meta_key = '_stock'";

                        if ($wpdb->query($query))
                          {

                            $response = "Success";
                          }

                        else
                          {

                            $response = "Failed";
                          }

                      }

                    if ($column == 'sku')
                      {

                        $table_name = $wpdb->prefix . 'postmeta';
                        $query = " UPDATE $table_name SET meta_value = '$val' WHERE post_id = '$id' AND meta_key = '_sku'";

                        if ($wpdb->query($query))
                          {

                            $response = "Success";
                          }

                        else
                          {

                            $response = "Failed";
                          }

                      }

                    if ($column == 'weight')
                      {

                        $table_name = $wpdb->prefix . 'postmeta';
                        $query = " UPDATE $table_name SET meta_value = '$val' WHERE post_id = '$id' AND meta_key = '_weight'";

                        if ($wpdb->query($query))
                          {

                            $response = "Success";
                          }

                        else
                          {

                            $response = "Failed";
                          }

                      }

                    if ($column == 's_status')
                      {

                        $table_name = $wpdb->prefix . 'postmeta';
                        $query = " UPDATE $table_name SET meta_value = '$val' WHERE post_id = '$id' AND meta_key = '_stock_status'";

                        if ($wpdb->query($query))
                          {

                            $response = "Success";
                          }

                        else
                          {

                            $response = "Failed";
                          }

                      }

                    if ($column == 'type')
                      {

                        $table_name = $wpdb->prefix . 'term_relationships';
                        $type_query = "SELECT `object_id` FROM {$wpdb->prefix}term_relationships WHERE `object_id` = '{$id}' AND term_taxonomy_id BETWEEN 2 AND 5";
                        $type_tax_query = "SELECT `term_taxonomy_id` FROM {$wpdb->prefix}term_relationships WHERE `object_id` = '{$id}' AND term_taxonomy_id BETWEEN 2 AND 5";

                        $type = $wpdb->get_var($type_query);
                        $type_id = $wpdb->get_var($type_tax_query);

                        if ($type == null || $type == '')
                          {

                            $query = " INSERT INTO  $table_name (object_id,term_taxonomy_id,term_order) VALUES ({$id},{$val},0)";

                          }

                        else
                          {

                            $query = " UPDATE $table_name SET term_taxonomy_id = '$val' WHERE object_id = '$id' AND term_taxonomy_id = '$type_id'";
                          }

                        if ($wpdb->query($query))
                          {

                            $response = "Success";
                          }

                        else
                          {

                            $response = "Failed";
                          }

                      }

                    if ($column == 'regular_price')
                      {

                        $table_name = $wpdb->prefix . 'postmeta';
                        $query = " UPDATE $table_name SET meta_value = '$val' WHERE post_id = '$id' AND meta_key = '_regular_price'";

                        if ($wpdb->query($query))
                          {

                            $response = "Success";
                          }

                        else
                          {

                            $response = "Failed";
                          }

                      }

                    if ($column == 'sale_price')
                      {

                        $table_name = $wpdb->prefix . 'postmeta';
                        $query = " UPDATE $table_name SET meta_value = '$val' WHERE post_id = '$id' AND meta_key = '_sale_price'";

                        if ($wpdb->query($query))
                          {

                            $response = "Success";
                          }

                        else
                          {

                            $response = "Failed";
                          }

                      }

                    if ($column == 'manage_stock')
                      {

                        $table_name = $wpdb->prefix . 'postmeta';
                        $query = " UPDATE $table_name SET meta_value = '$val' WHERE post_id = '$id' AND meta_key = '_manage_stock'";

                        if ($wpdb->query($query))
                          {

                            $response = "Success";
                          }

                        else
                          {

                            $response = "Failed";
                          }

                      }

                    if ($column == 'backorders')
                      {
                        $table_name = $wpdb->prefix . 'postmeta';
                        $query = " UPDATE $table_name SET meta_value = '$val' WHERE post_id = '$id' AND meta_key = '_backorders'";

                        if ($wpdb->query($query))
                          {

                            $response = "Success";
                          }

                        else
                          {

                            $response = "Failed";
                          }

                      }

                    /*if($column == 'Product_name'){
                    
                    $table_name = $wpdb->prefix . 'posts';
                    $query = " UPDATE $table_name SET post_title = '$val' WHERE ID = '$id'";
                    
                    if($wpdb->query($query)) {
                    
                    $response = "Success";
                    }
                    
                    else {
                    
                    $response = "Failed";
                    }
                    
                    } */

                    if ($column == 'category')
                      {

                        $table_name = $wpdb->prefix . 'term_relationships';

                        $cat = "SELECT * FROM {$wpdb->prefix}term_relationships WHERE object_id = '{$id}' AND term_taxonomy_id > 5";

                        $c_query = "SELECT COUNT(*) FROM {$wpdb->prefix}term_relationships WHERE object_id = '{$id}' AND term_taxonomy_id > 5 ";

                        $rowcount = $wpdb->get_var($c_query);

                        if ($rowcount > 0)
                          {

                            foreach ($wpdb->get_results($cat) as $key_cat => $row_cat)
                              {
                                $del_cat = "DELETE FROM {$wpdb->prefix}term_relationships WHERE `object_id` = '{$id}' AND `term_taxonomy_id` = '{$row_cat->term_taxonomy_id}' ";
                                $res = $wpdb->query($del_cat);

                              }

                          }

                        foreach ($val as $key => $value)
                          {

                            $query = " INSERT INTO  $table_name (object_id,term_taxonomy_id,term_order) VALUES ({$id},{$value},0)";
                            if ($wpdb->query($query))
                              {

                                $response = "Success";
                              }

                            else
                              {

                                $response = "Failed";
                              }

                          }

                      }

                    header("Content-Type: application/json");

                    echo json_encode($response);

                    exit();

                  }
                
                   function wsesp_ajax_2(){


 global $wpdb;
                       $id = $_POST['parent'];
    $var_orders_sql ="SELECT posts1.post_parent,posts.ID as product_id,posts2.post_title as parent_product, posts.post_title as Product_name, stockmeta2.meta_value as Stock_Left, stockmeta3.meta_value AS Stock_Status, stockmeta4.meta_value as sku, stockmeta5.meta_value as weight, ROUND(stockmeta6.meta_value, 2) as regular_price, ROUND(stockmeta7.meta_value, 2) as sale_price, stockmeta8.meta_value as manage_stock, stockmeta9.meta_value as backorders,type2.*,GROUP_CONCAT(attrmeta.meta_value)  as attribute,{$wpdb->prefix}terms.*, type1.term_taxonomy_id as type FROM {$wpdb->prefix}posts as posts  

LEFT JOIN {$wpdb->prefix}posts AS posts1 ON posts.ID = posts1.ID  
LEFT JOIN {$wpdb->prefix}posts AS posts2 ON posts1.post_parent = posts2.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS attrmeta ON attrmeta.post_id = posts.ID
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta2 ON stockmeta2.post_id = posts.ID
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta3 ON stockmeta3.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta4 ON stockmeta4.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta5 ON stockmeta5.post_id = posts.ID 
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta6 ON stockmeta6.post_id = posts.ID 
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta7 ON stockmeta7.post_id = posts.ID 
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta8 ON stockmeta8.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta9 ON stockmeta9.post_id = posts.ID
LEFT JOIN {$wpdb->prefix}term_relationships as type2 ON type2.object_id = posts.ID  
LEFT JOIN {$wpdb->prefix}term_relationships as type1 ON type1.object_id = posts.ID  
LEFT JOIN(SELECT term_taxonomy_id as tid FROM {$wpdb->prefix}term_taxonomy WHERE taxonomy IN('product_cat')) {$wpdb->prefix}term_taxonomy ON {$wpdb->prefix}term_taxonomy.tid = type2.term_taxonomy_id  
LEFT JOIN {$wpdb->prefix}terms ON {$wpdb->prefix}terms.term_id = type2.term_taxonomy_id

WHERE   posts.post_type   = 'product_variation'   
       AND stockmeta2.meta_key = '_stock'  
       AND stockmeta3.meta_key = '_stock_status' 
       AND stockmeta4.meta_key = '_sku' 
       AND stockmeta5.meta_key = '_weight' 
       AND stockmeta6.meta_key = '_regular_price' 
       AND stockmeta7.meta_key = '_sale_price' 
       AND stockmeta8.meta_key = '_manage_stock' 
       AND stockmeta9.meta_key = '_backorders' 
       AND attrmeta.meta_key LIKE 'attribute_%'
      
       AND posts1.post_parent = '{$id}'
       
        GROUP BY posts.ID ORDER BY posts.post_title ASC";
        foreach (($wpdb->get_results($var_orders_sql)) as $var_key => $value_key) {


            $results_var[] = $value_key;
        }
                     
        
                   
header("Content-Type: application/json");
        echo json_encode($results_var);

exit();
                 }

              }

            /**
             * Take care of anything that needs woocommerce to be loaded.
             * For instance, if you need access to the $woocommerce global
             */
            public function woocommerce_loaded()
              {

                if (current_user_can('manage_woocommerce'))
                  {
                    function wsesp_plugin_menu()
                      {
                        $icon_url = plugins_url('/assets/images/stocks.png', __FILE__);
                        $position = 59;
                        add_menu_page('WooCommerce Product & Stock Manager', 'WooCommerce Product & Stock Manager', 'manage_woocommerce', 'Woo-Stocks-Manager', 'wsesp_generate_products_table', $icon_url, $position);
                        add_submenu_page('Woo-Stocks-Manager', 'Woo-Stocks-Manager > Settings', 'Settings', 'manage_woocommerce', 'Woo-Stocks-Manager-Settings', 'wsesp_settings_forms_generate');

                      }
                  }

                function wsesp_core_scripts()
                  {

                    if ($_GET['page'] == 'Woo-Stocks-Manager-Settings' || $_GET['page'] == 'Woo-Stocks-Manager')
                      {

                        wp_enqueue_style('settings_Woostocks', plugins_url('/assets/css/settings.woostocks.css', __FILE__));
                        wp_enqueue_style('daterangepicker_Woostocks', plugins_url('/assets/css/daterangepicker.css', __FILE__));
                        wp_enqueue_style('bootstrap_Woostocks', plugins_url('/assets/css/bootstrap.css', __FILE__));
                        wp_enqueue_style('multiselect_Woostocks', plugins_url('/assets/css/multiselect.css', __FILE__));

                        wp_enqueue_style('fa', plugins_url('/assets/css/font-awesome.min.css', __FILE__));
                        wp_enqueue_style('datatable_css', plugins_url('/assets/css/datatable.css', __FILE__));
                        wp_enqueue_script('wsesp_moment_js', plugins_url('/assets/js/moment.js', __FILE__) , array(
                            'jquery'
                        ));

                        wp_enqueue_script('wsesp_bootstrap_js', plugins_url('/assets/js/bootstrap.js', __FILE__) , array(
                            'jquery'
                        ));

                        wp_enqueue_script('wsesp_multiselect_js', plugins_url('/assets/js/multiselect.js', __FILE__) , array(
                            'jquery'
                        ));

                        wp_enqueue_script('wsesp_daterange_js', plugins_url('/assets/js/daterangepicker.js', __FILE__) , array(
                            'jquery'
                        ));

                        wp_enqueue_script('wsesp_datatables_js', plugins_url('/assets/js/datatables.js', __FILE__) , array(
                            'jquery'
                        ));

                      }

                  }
                add_action('admin_enqueue_scripts', 'wsesp_core_scripts');

                // ...
                
              }

            /**
             * Take care of anything that needs all plugins to be loaded
             */
            public function plugins_loaded()
              {

              }

          }
        function wsesp_woostocksmanager_activate()
          {
            global $wpdb;
            global $woostocksmanager_db_version;
            $woostocksmanager_db_version = '1.0';

            $table_name = $wpdb->prefix . 'woostocksmanager_data';

            $charset_collate = $wpdb->get_charset_collate();

            $sql = "CREATE TABLE $table_name (
    id mediumint(9) NOT NULL AUTO_INCREMENT,
    email varchar(255) NOT NULL,
    woostocksmanager_key varchar(255) NOT NULL,
    instance varchar(255) NOT NULL,
    type varchar(255) NOT NULL,
    expiry varchar(255) NOT NULL,
    rec_value varchar(255) NOT NULL,
    PRIMARY KEY  (id)
  ) $charset_collate;";

            require_once (ABSPATH . 'wp-admin/includes/upgrade.php');
            dbDelta($sql);
            echo $wpdb->last_error;

          }
        register_activation_hook(__FILE__, 'wsesp_woostocksmanager_activate');

        // finally instantiate our plugin class and add it to the set of globals
        $GLOBALS['WS_Manager'] = new WS_Manager();
        define('Woo_Stocks_Path', plugin_dir_path(__FILE__));

        require_once (Woo_Stocks_Path . 'includes/class.core.woostocks.php');
        require_once (Woo_Stocks_Path . 'includes/class.settings.woostocks.php');

      }
  }

?>
